/*
 * engine.h
 *
 *  Created on: 27-05-2014
 *      Author: crm
 */

#pragma once

#include "asmmath.h"

namespace Engine
	{
	class Application
		{
		private:
			Application(const Application& e): run(true), cleared(true), dt(0.0f), frametime(0u), keystate(nullptr), mousemotion() {}
			Application& operator=(const Application& e) {return *this;}

			bool run;
			bool cleared;

			float dt;
			unsigned frametime;

			unsigned char *keystate;
			AVector mousemotion;

			// Render::Render *render;
			// Sound::Player *sound;

		public:
			 Application(): run(true), cleared(true), dt(0.0f), frametime(0u), keystate(nullptr), mousemotion() {}
			~Application() {clear();}

			bool init();
			void update();
			void clear();

			bool running();
			float delta();
			bool key(int sym);

			AVector getMouseMotion();
			AVector getMousePosition();
		};
	}
