/*
 * refcounted.h
 *
 *  Created on: 5 mar 2016
 *      Author: crm
 */


#pragma once

namespace Engine
	{
	class RefCounted
		{
		private:
			mutable int _refs;

		public:
			RefCounted(): _refs(0) {}
			RefCounted(const RefCounted& r): _refs(0) {}
			virtual ~RefCounted() {}

			virtual void   ref() const {++_refs;}
			virtual void unref() const {--_refs;}

			inline int refs() const {return _refs;}
			inline int valid() const {return _refs>0;}
		};
	}
