/*
 * imagemanager.h
 *
 *  Created on: 25-02-2013
 *      Author: crm
 */

#pragma once

#include "imageptr.h"

#include <string>

struct SDL_Surface;

namespace Engine
	{
	namespace ImageManager
		{
		enum class Type
			{
			IMG_32_RGBA,	// Domyslne
			IMG_32_ABGR,	// Wsteczne RGBA
			IMG_32_BGRA,	// Windowsowe 32 bity?						// A jednak nie.
			IMG_32_ARGB,	// Gdzies toto w ogole jest uzywane? o;		// A jednak tak.
			IMG_24_RGB,		// Chyba najprostsza sytuacja o;
			IMG_24_BGR,		// No, jeszcze kolejnosc wsteczna
			IMG_16_RGB_555,	// Nie zrobione~							// Juz zrobione~
			IMG_16_RGB_655,	// Windowsowe 16 bitow?
			IMG_16_RGB_565,	// Nie zrobione~							// Juz zrobione~
			IMG_16_RGB_556,	// Nie zrobione~							// Juz zrobione~
			IMG_8,			// Nope, to nie jest paletowe - skala odcieni szarosci

			IMG_32_WINDOWS=	IMG_32_ARGB,
			IMG_24_WINDOWS=	IMG_24_RGB,
			IMG_16_WINDOWS=	IMG_16_RGB_565,
			IMG_8_WINDOWS=	IMG_8,
			};

		ImagePtr get(const std::string& path);
		ImagePtr get(SDL_Surface* surface);
		ImagePtr get(const char *data, int w, int h, Type type=Type::IMG_32_RGBA);
		ImagePtr get(unsigned tex, int w, int h);

		void free(const Image* img, bool erase=true);

		//void flush(); // Nie potrzeba, liczenie referencji dziala sprawnie~
		/*void reload();*/
		void clear();
		}
	}
