/*
 * imageptr.h
 *
 *  Created on: 7 mar 2016
 *      Author: crm
 */

#pragma once

#include "image.h"

namespace Engine
	{
	class ImagePtr
		{
		private:
			const Image *image;

			void assign(const Image *s);

		public:
			ImagePtr(): image(nullptr) {}
			ImagePtr(const Image* s): image(nullptr) {assign(s);}
			ImagePtr(const ImagePtr& s): image(nullptr) {assign(s.image);}
			virtual ~ImagePtr() {assign(nullptr);}

			ImagePtr& operator=(const Image* s) {assign(s); return *this;}
			ImagePtr& operator=(const ImagePtr& s) {assign(s.image); return *this;}
			const Image& operator*() const {return *image;}
			const Image* operator->() const {return image;}
			operator bool() const {return image;}
			operator const Image*() const {return image;}
		};
	}
