/*
 * base.h
 *
 *  Created on: 03-04-2013
 *      Author: crm
 */

#pragma once

#include "defs.h"
#include "rect.h"

namespace Engine
	{
	namespace UI
		{
		class Base
			{
			protected:
				Rect rect;

				ClickAction cbclick;

			public:
				Base();
				virtual ~Base();

				virtual void init(Rect r);
				virtual void update(float dt);
				virtual void print();
				virtual void clear();

				virtual void click(int x, int y);
				virtual void hover(int x, int y);

				void setClick(ClickAction s) {cbclick=s;}

				bool isIn(int x, int y) {return rect.isIn(x, y);}
			};
		}
	}
