/*
 * CounterAnimated.cpp
 *
 *  Created on: 26-03-2013
 *      Author: crm
 */

#include "counteranimated.h"

#include "../render/render.h"

using namespace Engine::UI;

CounterAnimated::CounterAnimated(): Counter()
	{
	//
	}

CounterAnimated::~CounterAnimated()
	{
	clear();
	}

void CounterAnimated::init(const std::string& name, float min, float max, float val)
	{
	Counter::init(min, max, val);
	spr.setSprite(name);
	}


void CounterAnimated::update(float dt)
	{
	if(value<min)
		value=min;
	else if(value>max)
		value=max;

	unsigned anim=(value-min)/(max-min)*(spr->getAnimationCount()-1);

	spr.setAnimation(anim);
	spr.update(dt);
	}

void CounterAnimated::print(float x, float y)
	{
	//Render::print(spr, x, y, 0.0f);
	}

void CounterAnimated::clear()
		{
		spr.clear();
		}
