/*
 * collider.h
 *
 *  Created on: 26 kwi 2016
 *      Author: crm
 */


#pragma once

#include "box.h"

namespace Game
	{
	class Collider: public Box
		{
		private:
			float friction;

		public:
			Collider(): Box(), friction(1.0f) {}
			Collider(const AVector& pos, const AVector& size, float friction=1.0f): Box(pos, size), friction(friction) {}

			Collider operator+(const AVector& v) const {return Collider(pos+v, size, friction);}
			Collider operator-(const AVector& v) const {return Collider(pos-v, size, friction);}

			float getFriction() const {return friction;}
		};
	}
