/*
 * ctrl_keyboard.h
 *
 *  Created on: 23-04-2013
 *      Author: crm
 */

#pragma once

#include <string>

namespace Game
	{
	class Controller
		{
		public:
			enum Key
				{
				LEFT=    0x0,
				RIGHT=   0x1,
				JUMP=    0x2,
				CONFIRM= 0x3,
				PREVIOUS=0x4,
				NEXT=    0x5,
				COUNT,
				};

		protected:
			int keys[COUNT];
			bool pstate[COUNT];
			int change[COUNT];
			unsigned char *state;

		public:
			Controller() {};
			virtual ~Controller() {clear();}

			bool init(const std::string& configdb, const std::string& prefix);
			bool init();
			void update(float dt);
			void clear();

			bool isPressed(Key c);
			bool onKeyDown(Key c);
			bool onKeyUp(Key c);
		};
	}
