/*
 * object.cpp
 *
 *  Created on: 26 kwi 2016
 *      Author: crm
 */

#include "object.h"

#include "../engine/render/render.h"
#include "objecttemplate.h"
#include "level.h"

using namespace Game;
using namespace Engine;

Object::Object(const ObjectTemplate *tobj, bool withColliders): pos(), level(nullptr), game(nullptr), tobj(tobj)
	{
	boundingbox=tobj->getBoundingBox();
	if(withColliders)
		colliders=tobj->getColliders();
	sprite.setSprite(tobj->getSprite());

	sprite.setDirection((unsigned)Engine::Sprite::DirectionName::LEFT);
	}


void Object::update(float dt)
	{
	sprite.update(dt);
	}

void Object::print()
	{
	//AVector ipos=AVector(floor(pos.x), floor(pos.y), pos.z);
	//Render::print(sprite, Orientation(ipos, Orientation::FLAT_XY));

	Render::print(sprite, Orientation(pos, Orientation::FLAT_XY));

	/*if(boundingbox.size.x!=0.0f)
		{
		Render::setColor(AVector(1, 0, 0, 0.2f));
		Render::drawRectLine(pos+boundingbox.pos+AVector(0, 0, 2), pos+boundingbox.pos+boundingbox.size);
		}

	for(auto& c: colliders)
		{
		Render::setColor(AVector(1, 0, 0.5f, 0.5f));
		Render::drawRectLine(pos+c.pos+AVector(0, 0, 3), pos+c.pos+c.size);
		}

	Render::setColor(AVector(1, 1, 1, 1));*/
	}

void Object::clear()
	{
	colliders.clear();
	sprite.clear();
	}


/*char* Object::serialize(int &size)
	{
	return nullptr;
	}

void Object::deserialize(char *buff)
	{
	//
	}*/


Collider Object::test(const Box& b) const
	{
	for(const Collider& c: colliders)
		{
		const Collider cc=c+pos;

		if(cc.collision(b))
			return cc;
		}

	return Collider();
	}

