/*
 * particle.h
 *
 *  Created on: 14 maj 2016
 *      Author: crm
 */

#pragma once

#include "asmmath.h"

#include "../engine/render/spriteptr.h"

namespace Game
	{
	class Level;
	class Object;

	class Particle
		{
		public:
			enum class Type
				{
				STATIC,
				FOLLOW_OBJECT,
				LINEAR_MOVE,
				GRAVITY_MOVE,
				};

		protected:
			AVector pos;
			AVector spd;

			Engine::SpritePtr sprite;

			float ttl;

			Type type;

			Level *lvl;

			AVector offset;
			Object *target;

		public:
			Particle(): pos(), spd(), sprite(), ttl(1.0f), type(Type::STATIC), lvl(nullptr), target(nullptr)
				{
				//
				}

			virtual ~Particle()
				{
				clear();
				}

			bool init(const Engine::SpritePtr& sprite, Type type, float ttl);
			bool init(const Engine::SpritePtr& sprite, float ttl, AVector offset, Object *target);
			bool init(const Engine::SpritePtr& sprite, float ttl, AVector spd);
			void update(float dt);
			void print();
			void clear();

			bool isDead() const {return ttl<=0.0f;}

			void setLevel(Level *s) {lvl=s;}
			void setPosition(const AVector& s) {pos=s;}
			void setSpeed(const AVector& s) {spd=s;}
		};

	}
