/*
 * player.h
 *
 *  Created on: 7 maj 2016
 *      Author: crm
 */

#pragma once

#include "activeobject.h"
#include "controller.h"

namespace Game
	{
	class NPC;

	class Player: public ActiveObject
		{
		protected:
			enum class PlayerMode
				{
				NORMAL,
				TALKING,
				};

			PlayerMode mode;

			Controller ctrl;

			NPC *dialnpc;

		public:
			Player();
			Player(const ObjectTemplate *tobj, bool withColliders=true);

			bool init();
			virtual void update(float dt);
			virtual void print();
			virtual void clear();

			virtual char* serialize(int &size);
			virtual void deserialize(char *buff);

			NPC* getDialogueNPC() const {return dialnpc;}

			void setPlayerModeTalking() {mode=PlayerMode::TALKING;}
			void setPlayerModeNormal() {mode=PlayerMode::NORMAL;}

			bool isTalking() const {return mode==PlayerMode::TALKING;}
		};
	}
